<?php

// This include file is used to define custom replacements in the place string

include($cms[tngpath] . "substitution_list.php");

function linkWiki( $cat, $place ) {

	global $currentuser,$allow_admin, $searchlist, $replacelist;
	//
	// INPUT
	//
	// $cat is the GenWiki Category that will be used for the link to the GenWiki page
	// $place is the original location string provided by TNG
	// 
	// RETURNS
	// 
	// if $cat = "Places" and a GenWiki page IS found
	//   then the $place string is returned as a link to the GenWiki page with an appropriate ALT tag
	//
	// if $cat = "Places" and a GenWiki page is NOT found, and the user is NOT the Administrator
	//   then the original $place string is returned
	//
	// if $cat = "Places" and a GenWiki page is NOT found, and the user IS the Administrator
	//   then the $place string is returned as original, and followed by a GenWiki page create icon
	//
	// if $cat is NOT "Places", this function currently assumes a simple page match is desired
	//
	// if the simple GenWiki page match is made
	//   then a GenWiki page icon&link is display, with an ALT tag
	//
	// if the simple GenWiki page match is NOT made and the user is NOT the Administrator
	//   then a null string is returned
	//
	// if the simple GenWiki page does NOT match, and the user IS the Administrator
	//   then a GenWiki page create icon is displayed
	//
	// REQUIRED USER CONFIGURATION
	//
	// The following variables must be specified for your specific server and wiki setup
	
	$wiki_url = "http://genwiki.mcfadyen.ca";
	$wiki_prefix = "wiki_";
	//
	// The following option must be selected based upon the URL path type used in your wiki Installation
	// Check you LocalSettings.php file in the base directory, the option $wgArticlePath will define the
	// choice here
	//
	$wiki_url_type = "/";
	//$wiki_url_type = "?title=";

	$retstr = "";			

	if($cat == "Places") {
		$retstr = $place;
	  $placestr = trim($place);														// remove spaces and junk from the ends
	  $placestr = ereg_replace(" [ ]*"," ",$placestr);		// replace multiple spaces with single spaces
	  $placestr = str_replace(" ,",",",$placestr);				// remove spaces before commas
	  $placestr = str_replace(", ",",",$placestr);				// remove spaces after commas
	  list($orig[0],$orig[1],$orig[2],$orig[3],$orig[4],$orig[5],$orig[6],$orig[7],$orig[8]) = explode(",",$placestr);
	  $newplacestr = $placestr;														// save this version in case there is no match
	  $placestr = ereg_replace("\(.*\){1}","",$placestr);	// remove bracketed stuff
	  $placestr = str_replace(" ,",",",$placestr);				// remove spaces before commas
	  $placestr = str_replace(", ",",",$placestr);				// remove spaces after commas
	  $placestr = trim($placestr) . ",";												// remove spaces at ends and add a comma for easier substitutions
	  $placestr = str_replace($searchlist, $replacelist, $placestr);	// do substitutions
	  $placestr = str_replace(" ","_",$placestr);				// replace spaces with underscore
	  list($seg[0],$seg[1],$seg[2],$seg[3],$seg[4],$seg[5],$seg[6],$seg[7],$seg[8]) = explode(",",$placestr);
	  for($i=0; $i<=8; $i++){
	  	$seg[$i] = trim($seg[$i]);		// clean up the ends of the search segments
	  	$orig[$i] = trim($orig[$i]);	// clean up the ends of the display segments
	  }
	  //
	  // search for page matches, starting with first segment, then append the next, and the next
	  // if any pages are found, the match will be the one with the most matching segments
	  // after the first match, continue with the rest of the string and see if there are any other
	  // matches
	  //
	  $match_string = "";
	  $match_display_string = "";
	  $final_string = "";

	  for($j=0; ($j<=8) && ($seg[$j] != ""); $j++){
	  	$remaining_segs = $j;
	  	$search_string = "";
	    $display_string = "";
	  	for($i=$j; ($i<=8) && ($seg[$i] != ""); $i++){
		  	if ($i != $j){
		  		$search_string .= ",";
		  		$display_string .= ", ";
		  	}
		  	$search_string .= $seg[$i];
		  	$display_string .= $orig[$i];
		    $dbw_query = "SELECT page_title FROM " . $wiki_prefix . "page WHERE page_title=\"$search_string\"";
		    $therows = mysql_query($dbw_query);
		    if(mysql_num_rows($therows) > 0 ){
		    	$match_string = $search_string;
	  			$match_display_string = $display_string;
		    	$remaining_segs = $i+1;
		    }
		  }
		  if($j != 0){
		  		$final_string .= ", ";
		  }
		  if($remaining_segs == $j){
		  	$final_string .= $orig[$j];
		  } else {
		  	$final_string .= "<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $match_string . "\"" . 
		  	                 "/>" . $match_display_string . "</a>";
		  	$j = $remaining_segs-1;
		  }
	  }
	  $retstr = $final_string;

	  if($allow_admin && $match_string == "") {
					$retstr .= "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php" . $wiki_url_type . $newplacestr . 
									   "\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $newplacestr\"/></a>";	
	  }
	} else {
	  $placestr = trim($place);					// remove spaces and junk from the ends
	  $placestr = ereg_replace(" ","_",$placestr);		// replace spaces with underscore
	  if( $placestr != "") {
	    $dbw_query = "SELECT page_title FROM " . $wiki_prefix . "page WHERE page_title=\"$placestr\"";
	    $therows = mysql_query($dbw_query);
		  if($therows){
			  if(mysql_num_rows($therows) > 0) {
				  $retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php/" . $placestr . 
				  				  "\"><img src=\"doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Additional Information on $place\"/></a>";
			  } else {
			    if($allow_admin){
				    $retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php/" . $placestr . 
				    					"\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $place\"/></a>";
			    }
			  }
		  } else {
			  if($allow_admin){
				  $retstr = "&nbsp;&nbsp;<a href=\"" . $wiki_url . "/index.php/" . $placestr . 
				  					"\"><img src=\"new_doc.gif\" width=\"11\" height=\"13\" border=\"0\" alt=\"Add Information for $place\"/></a>";
			  }
		  }
		}
	}
	if($therows) mysql_free_result($therows);
	return $retstr;
}
?>
